/*
 * servo.c
 *
 *  Created on: 12 Jan 2025
 *      Author: user
 */
#include "servo.h"
#include "led.h"
#include "board.h"
#include "peripherals.h"
#include "pin_mux.h"
#include "clock_config.h"
#include "MK66F18.h"
#include "fsl_debug_console.h"


// Function to set the servo position based on the desired duty cycle
void setServoPosition(float duty_cycle) {
    // Update PWM duty cycle for SERVO0 (FTM3 CH6)
    FTM_UpdatePwmDutycycle(FTM3_PERIPHERAL, FTM3_FTM_SERVO_CHANNEL, kFTM_EdgeAlignedPwm, duty_cycle);
    FTM_SetSoftwareTrigger(FTM3_PERIPHERAL, true); // Apply the new duty cycle
}

// Function to turn the car left
void turnLeft() {
    float duty_cycle = 5.0; // 1ms pulse width -> 5% duty cycle
    turnOff();
    leftLight();
    setServoPosition(duty_cycle);
}

// Function to turn the car right
void turnRight() {
    float duty_cycle = 9.0; // 2ms pulse width -> 10% duty cycle
    turnOff();
    rightLight();
    setServoPosition(duty_cycle);
}

// Function to center the servo (straight position)
void centerServo() {
    float duty_cycle = 7.5; // 1.5ms pulse width -> 7.5% duty cycle
    turnOff();
    whiteLight();
    setServoPosition(duty_cycle);
}
